//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008"
#property link      " mail "

extern double  RiskPercentage = 10;    //   
extern int     pf_level_1 = 10;        //   (),       + 1 ;
extern int     pf_level_2 = 15;        //   (),      +1   pf_level_1    ;
extern int     pf_level_3 = 20;        //   (),      pf_level_1  pf_level_2     (    );
extern int     pf_level_4 = 50;        //   (),      Shadows;
extern int     tmfrm = 1;              // ,      (1, 5, 15, 30, 60, 240, 1440, 10080, 43200)
extern int     bars_n = 5;             // - ,    
extern int     indent = 1;             //    ,    
extern int     StopLoss = 10;          // 
extern int     magicnumber = 777;
extern int     MaxOrders =  0;         //  - ( 0 )
extern int     Test = 7;               //  RSI
extern int     BuyOp = 20;             //   
extern int     SellOp = 70;            //   

int prevtime;

int start()
  {
   double margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double step =   MarketInfo(Symbol(), MODE_LOTSTEP);
   double account = AccountFreeMargin();
   double percentage = account*RiskPercentage/100;
   double Lots = MathRound(percentage/margin/step)*step;  
   if(Lots < minLot)
   {
      Lots = minLot;
   }
   if(Lots > maxLot)
   {
      Lots = maxLot;
    
   int i=0;  
   int total = OrdersTotal();
   for(i = 0; i <= total; i++)
     {               
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);    
     if(OrderMagicNumber() == magicnumber)
       {
         Trailing(OrderTicket(), pf_level_1, pf_level_2,pf_level_3, pf_level_4, tmfrm, bars_n, indent);
       }
     }
     

   bool BuyOp=false;
   bool SellOp=false;

   if ((Low[0]>Low[1]&&Low[1]>Low[2]&&Low[2]>Low[3]&&Open[0]>Open[1]&&Open[1]>Open[2]&&Open[2]>Open[3]) && (iRSI(NULL,0,Test,PRICE_CLOSE,0) < BuyOp) && (iRSI(NULL,0,Test,PRICE_CLOSE,0) > iRSI(NULL,0,Test,PRICE_CLOSE,1)))
   BuyOp=true;
   if ((High[0]<High[1]&&High[1]<High[2]&&High[2]<High[3]&&Open[0]<Open[1]&&Open[1]<Open[2]&&Open[2]<Open[3]) && (iRSI(NULL,0,Test,PRICE_CLOSE,0) > SellOp) && (iRSI(NULL,0,Test,PRICE_CLOSE,0) < iRSI(NULL,0,Test,PRICE_CLOSE,1)))
   SellOp=true;
      
   if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];
   if(!IsTradeAllowed()) 
     {
       prevtime = Time[1];
       return(0);
     }
   }
   if (total < MaxOrders || MaxOrders == 0)
     {   
       if(BuyOp)
        { 
         if (StopLoss!=0)
          {
           OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-(StopLoss*Point),0,"OpenTiks_Buy",magicnumber,0,Green);
          }
         else
          {
           OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"OpenTiks_Buy",magicnumber,0,Green);
          }
        }
       if(SellOp)
        { 
         if (StopLoss!=0)
          {
           OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+(StopLoss*Point),0,"OpenTiks_Sell",magicnumber,0,Red);
          } 
         else 
          {
           OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"OpenTiks_Sell",magicnumber,0,Red);
          }
        }
      }
   
//----
   return(0);
  } 
//+------------------------------------------------------------------+
void Trailing(int ticket,int pf_level_1,int pf_level_2,int pf_level_3,int pf_level_4,int tmfrm,int bars_n,int indent)
   {
   //   
   if ((ticket==0) || (!OrderSelect(ticket,SELECT_BY_TICKET)) || (pf_level_2<=pf_level_1) || (pf_level_3<=pf_level_2) || 
   (pf_level_3<=pf_level_1) || (pf_level_2-pf_level_1<=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) || (pf_level_3-pf_level_2<=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point) ||
   (pf_level_1<=MarketInfo(Symbol(),MODE_STOPLEVEL)) || (bars_n<1) || (indent<0) || ((tmfrm!=1) && (tmfrm!=5) && (tmfrm!=15) && (tmfrm!=30) && (tmfrm!=60) && (tmfrm!=240) && (tmfrm!=1440) && (tmfrm!=10080) && (tmfrm!=43200)))
      {
      Print("  Trailing()  -     .");
      return(0);
      }
      
   //    (OP_BUY)
   if (OrderType()==OP_BUY)
      {
double dBid = MarketInfo(Symbol(),MODE_BID);    
      //    
      //   "_-_"   "pf_level_4+",   TrailingByShadows"
      if ((dBid-OrderOpenPrice())>=pf_level_4*Point)
         { 
int l; //   Low
double new_extremumL;
      for(l=1;l<=bars_n;l++)
            {
            if (l==1) 
            new_extremumL = iLow(Symbol(),tmfrm,l);
            if (new_extremumL>iLow(Symbol(),tmfrm,l)) 
            new_extremumL = iLow(Symbol(),tmfrm,l);
            }
         //    "" , 
         if ((new_extremumL - indent*Point)>OrderStopLoss()) 
            OrderModify(ticket,OrderOpenPrice(),new_extremumL-indent*Point,OrderTakeProfit(),OrderExpiration());
            
         //   "_-_"   "pf_level_3+",    "pf_level_2+"
         }
      if ((dBid-OrderOpenPrice())>=pf_level_3*Point)
         {
         if (OrderStopLoss()<OrderOpenPrice() + pf_level_2 *Point)
            OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() + pf_level_2*Point,OrderTakeProfit(),OrderExpiration());
         }
         //   "_-_"   "pf_level_2+",    "pf_level_1+"
      if ((dBid-OrderOpenPrice())>=pf_level_2*Point)
         {
         if ((OrderStopLoss()<OrderOpenPrice() + pf_level_1*Point))
            OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() + pf_level_1*Point,OrderTakeProfit(),OrderExpiration());
         }
         //   "_-_"   "pf_level_1+",    +1 (" + ")
      if ((dBid-OrderOpenPrice())>=pf_level_1*Point)
         //        "+1"
         {
         if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice() + 1*Point))
            OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() + 1*Point,OrderTakeProfit(),OrderExpiration());
         }
      }            
   if (OrderType()==OP_SELL)  //    (OP_SELL)
      {
   double dAsk = MarketInfo(Symbol(),MODE_ASK);
         //    
         //   "_-_"   "pf_level_4+",   TrailingByShadows"
      if ((OrderOpenPrice()-dAsk)>=pf_level_4*Point)
         { 
   int h; //   High
   double new_extremumH;
         for(h=1;h<=bars_n;h++)
            {
            if (h==1) 
            new_extremumH = iHigh(Symbol(),tmfrm,l);
            if (new_extremumH>iHigh(Symbol(),tmfrm,l)) 
            new_extremumH = iHigh(Symbol(),tmfrm,l);
            }
         //    "" , 
         if ((new_extremumH + (indent + MarketInfo(Symbol(),MODE_SPREAD))*Point)<OrderStopLoss())
            OrderModify(ticket,OrderOpenPrice(),new_extremumH + (indent + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration());        
         }    
      //   "_-_"   "pf_level_3+",    "pf_level_2+"
      if ((OrderOpenPrice()-dAsk)>=pf_level_3*Point)
         {
         if (OrderStopLoss()>OrderOpenPrice() - (pf_level_2 + MarketInfo(Symbol(),MODE_SPREAD))*Point)
         OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() - (pf_level_2 + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration());
         }
         //   "_-_"   "pf_level_2+",    "pf_level_1+"
      if ((OrderOpenPrice()-dAsk)>=pf_level_2*Point)
         {
         if (OrderStopLoss()>OrderOpenPrice() - (pf_level_1 + MarketInfo(Symbol(),MODE_SPREAD))*Point)
         OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() - (pf_level_1 + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration());
         }
         //   "_-_"   "pf_level_1+",    +1 (" + ")
      if ((OrderOpenPrice()-dAsk)>=pf_level_1*Point)
         //        "+1"
         {
         if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice() - (1 + MarketInfo(Symbol(),MODE_SPREAD))*Point))
         OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice() - (1 + MarketInfo(Symbol(),MODE_SPREAD))*Point,OrderTakeProfit(),OrderExpiration());
         }
      } 
   }

